Page MenuHomePhabricator

Abandon support for Python 2.6
Closed, ResolvedPublic

Description

We have few places where Python 2.6.x is mentioned as supported (see e.g.: 1, 2).

Meanwhile in few other places it's not (see e.g. PyPI).

It also worth mentioning that Python 2.6 is not supported by PSF since 2013-10-29. And few days ago incompatible change landed in our master, causing our Travis build to fail (see e.g.: 3).

It would be great to discuss this issue and decide if we want still to support 2.6 or not.

I'm for abandoning it.

UPDATE:
Be aware that 2.0 branch abandon 2.6 (see: T114464) and for master branch there were discussion and it was rejected to abandon 2.6 (see: T103063).

Details

Event Timeline

Magul created this task.Jan 6 2017, 2:07 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJan 6 2017, 2:07 PM
Restricted Application added a subscriber: pywikibot-bugs-list. · View Herald TranscriptJan 6 2017, 2:35 PM

A agree deprecating py2.6. On the other hand please refer John's comment at my path set https://gerrit.wikimedia.org/r/#/c/263372/

Magul added a comment.Jan 12 2017, 7:16 PM

It looks like Your patch requires rebase and it should also remove Python 2.6 from Travis CI and Appveyor CI.

We can also include fresh Python 3.6 in this patch. What do You think?

If You're willing to rebase and resolve this issues, I'm would love to merge it (it has been there for over the year and I believe @Multichill would already opposed).

Magul updated the task description. (Show Details)Jan 12 2017, 10:52 PM

This sounds good to me. I think an email to pywikibot@ soliciting more input would be a good step.

Change 331940 had a related patch set uploaded (by Magul):
Abandon Python 2.6 and indtroduce Python 3.6 on CI infrastructure

https://gerrit.wikimedia.org/r/331940

Magul added a comment.Jan 13 2017, 1:00 AM

Ok @Xqt I upload patch that abandon 2.6 and introduce 3.6 on our Travis CI and Appveyor CI. Feel free to review.

jayvdb updated the task description. (Show Details)Jan 13 2017, 1:55 AM
jayvdb updated the task description. (Show Details)Jan 13 2017, 2:00 AM

The pypi package doesnt support py26 as pypi is intended to be a stable/supported release, and py26 is not stable/support-able.

The master branch isnt officially supported, which means any py26 user can raise a bug and/or fix it, if they want to.

If there are persistent problems with py26, the travis py26 job can be marked as an "allowed failure", but that is a bit pointless at the moment as there are truckloads of other travis build problems on supported version that have yet to be resolved.

I have created T155208 as a low priority task to fix the py26 breakage, and I will fix it if the GCI participant doesnt fix it. It is only a few lines to fix, and we even discussed these lines during the code review, and the safer approach wasnt used because I forgot why we should use the safer approach.

These breakages occur because the Travis builds are no longer a reasonable part of our merging checklist process; there are still too many failures, but I have noticed it is getting much, much better lately and thanks to everyone involved. Hopefully next GSOC and GCI we can do real serious enhancements again.

If there are no more py26 users, removing py26 from master is sensible.

This sounds good to me. I think an email to pywikibot@ soliciting more input would be a good step.

This hasnt been done as far as I can see.

@Multichill is the main person who has been using the py26 support, and is active in the community, but I have ran into other people who were using it a year ago.

Most of our users are not active in gerrit and phabricator, and the mailing list is the only way to involve them in decision making.

FYI, Enterprise Linux 6 (RedHat & CentOS 6), which have an EOL in 2020, use a system python of python 2.6, and it's not upgradeable (otherwise yum package manager breaks). I can't say for other EL6 users/sysadmins, but I myself learned to just compile a python 2.7 if I need to do anything serious in python on those hosts.

Dalba awarded a token.
whym awarded a token.Dec 5 2017, 7:41 AM

Yeah, let's just drop 2.6 . Switching away from Redhat anyway :-)

Change 263372 had a related patch set uploaded (by Xqt; owner: Xqt):
[pywikibot/core@master] Do not setup pypi package for python 2.6

https://gerrit.wikimedia.org/r/263372

Xqt added a comment.Dec 17 2017, 4:27 PM
This comment was removed by Xqt.

Change 403404 had a related patch set uploaded (by Xqt; owner: Xqt):
[pywikibot/core@master] DeprecationWarning: support for py2.6 and py3.3 will be dropped

https://gerrit.wikimedia.org/r/403404

Xqt triaged this task as Medium priority.Jan 10 2018, 5:18 PM

Change 404055 had a related patch set uploaded (by Dalba; owner: Dalba):
[pywikibot/core@master] DeprecationWarning: support for py2.6 and py3.3 will be dropped

https://gerrit.wikimedia.org/r/404055

Change 404055 merged by jenkins-bot:
[pywikibot/core@master] DeprecationWarning: support for py2.6 and py3.3 will be dropped

https://gerrit.wikimedia.org/r/404055

Xqt added a comment.Jan 20 2018, 1:52 PM

See also this deprecation warning from python core team

See also this deprecation warning from python core team

link to warning

Dvorapa renamed this task from [RfC] Abandon support for Python 2.6 to Abandon support for Python 2.6.Feb 1 2018, 11:25 AM
Dvorapa removed a project: Pywikibot-RfCs.
Dvorapa added a subscriber: Dvorapa.EditedFeb 1 2018, 11:46 AM

I think https://gerrit.wikimedia.org/r/#/c/403404/ should be incorporated into https://gerrit.wikimedia.org/r/#/c/263372/, which seems to me as the main deprecation work, and both should be merged together

Xqt claimed this task.Apr 1 2018, 8:26 PM
Dalba closed this task as Resolved.Apr 2 2018, 1:38 AM
Dalba added a subscriber: Dalba.

🎈🎉

Change 263372 merged by jenkins-bot:
[pywikibot/core@master] Abandon support for python 2.6

https://gerrit.wikimedia.org/r/263372

Change 489452 had a related patch set uploaded (by Xqt; owner: Xqt):
[pywikibot/core@master] [doc] remove deprecated backports.py from CONTENT.rst

https://gerrit.wikimedia.org/r/489452

Change 489452 abandoned by Xqt:
[doc] remove deprecated backports.py from CONTENT.rst

Reason:
I guess this will never be removed

https://gerrit.wikimedia.org/r/489452

Change 491034 had a related patch set uploaded (by Xqt; owner: Xqt):
[pywikibot/core@master] [cleanup] Remove old py2.6 checking

https://gerrit.wikimedia.org/r/491034

Change 491034 merged by jenkins-bot:
[pywikibot/core@master] [cleanup] Remove old py2.6 checking

https://gerrit.wikimedia.org/r/491034